; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	temp (DATEN)														
;																				
EEPROM_READ_Z_PLUS_TEMP:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_Z_PLUS_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
; 		 	temp  DATEN															
;																				
EEPROM_WRITE_Z_PLUS_TEMP:
	GELB_ON
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_PLUS_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; ADRESSE +1 							
	GELB_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_LOAD:
	ldi ZL,low (2)
	ldi ZH,high(2)

	rcall EEPROM_READ_Z_PLUS_TEMP	; Menue	
	STS(adr_MENUE),temp

	rcall EEPROM_READ_Z_PLUS_TEMP	; P-max	
	STS(adr_P_max),temp

	rcall EEPROM_READ_Z_PLUS_TEMP	; ss	
	STS(adr_ss),temp	

	rcall EEPROM_READ_Z_PLUS_TEMP	; mm	
	STS(adr_mm),temp	

	rcall EEPROM_READ_Z_PLUS_TEMP	; hh	
	STS(adr_hh_L),temp	

	rcall EEPROM_READ_Z_PLUS_TEMP	; hh	
	STS(adr_hh_H),temp	

	rcall EEPROM_READ_Z_PLUS_TEMP	; Ws	
	STS(adr_Ws_0),temp

	rcall EEPROM_READ_Z_PLUS_TEMP	; Ws	
	STS(adr_Ws_1),temp

	rcall EEPROM_READ_Z_PLUS_TEMP	; Ws	
	STS(adr_Ws_2),temp

	rcall EEPROM_READ_Z_PLUS_TEMP	; Ws	
	STS(adr_Ws_3),temp

ret
	;Testzahl			
.equ LEISTUNG=10	;Watt	
.equ ZEIT    =10	;Stunden

	ldi temp1,Byte1(LEISTUNG*ZEIT*3600)
	ldi temp2,Byte2(LEISTUNG*ZEIT*3600)
	ldi temp3,Byte3(LEISTUNG*ZEIT*3600)
	ldi temp4,Byte4(LEISTUNG*ZEIT*3600)
	STS(adr_Ws_0),temp1
	STS(adr_Ws_1),temp2
	STS(adr_Ws_2),temp3
	STS(adr_Ws_3),temp4


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_SAVE:
	ldi ZL,low (2)
	ldi ZH,high(2)

	LDS temp,(adr_MENUE)			; Menue	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_P_max)			; P-max	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_ss)				; ss	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_mm)				; mm	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_hh_L)				; hh	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_hh_H)				; hh	
	rcall EEPROM_WRITE_Z_PLUS_TEMP

	LDS temp,(adr_Ws_0)				; Ws	
	rcall EEPROM_WRITE_Z_PLUS_TEMP
	LDS temp,(adr_Ws_1)				; Ws	
	rcall EEPROM_WRITE_Z_PLUS_TEMP
	LDS temp,(adr_Ws_2)				; Ws	
	rcall EEPROM_WRITE_Z_PLUS_TEMP
	LDS temp,(adr_Ws_3)				; Ws	
	rcall EEPROM_WRITE_Z_PLUS_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

