; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	BEEP_OFF
	LDS temp,(adr_TASTE)
	tst temp
	brne MENUE_TASTE
	STS(adr_COUNTER_MENUE),NULL
	rjmp MENUE_RUN	
;-------------------------------------------------------------------------------
MENUE_TASTE:
	rcall BEEP_1ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	GRUEN2_OFF
	GELB2_OFF
	cpi temp,1
	breq MENUE_PLUS	;Taste Menue Plus	
	cpi temp,2
	breq MENUE_CLEAR;Taste Menue Clear	
	STS(adr_COUNTER_MENUE),NULL
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
; CLEAR Taste gedrckt															
MENUE_CLEAR:
	rcall LED_MINUS
	STS(adr_MENUE),NULL		; NULL
	LDS temp1,(adr_COUNTER_MENUE)
	inc temp1
	STS(adr_COUNTER_MENUE),temp1
	rcall ZAHL_TEMP1
	STS(adr_DIGIT5),temp2
	STS(adr_DIGIT4),temp1

	LDS temp,(adr_COUNTER_MENUE)
	cpi temp,6
	breq MENUE_CLEAR_P
	cpi temp,20
	breq MENUE_CLEAR_kWh
	ret
;-------------------------------------------------------------------------------
; P clear																		
MENUE_CLEAR_P:
	STS(adr_MENUE),EINS	; EINS 
	STS(adr_P_max),NULL	; P-max

	rcall EEPROM_SAVE

	ldi temp9,5
MENUE_CLEAR_P_s:
	rcall BEEP_100ms
	rcall WAIT_100ms
	dec temp9
	brne MENUE_CLEAR_P_s
	ret
;-------------------------------------------------------------------------------
; kWh clear																		
MENUE_CLEAR_kWh:
	STS(adr_MENUE),EINS	; Menue	
	STS(adr_P_max),NULL	; P-max	
	STS(adr_ss),NULL	; ss	
	STS(adr_mm),NULL	; mm	
	STS(adr_hh_L),NULL	; hh	
	STS(adr_hh_H),NULL	; hh	
	STS(adr_Ws_0),NULL	; Ws	
	STS(adr_Ws_1),NULL	; Ws	
	STS(adr_Ws_2),NULL	; Ws	
	STS(adr_Ws_3),NULL	; Ws	

	rcall EEPROM_SAVE

	ldi temp9,5
MENUE_CLEAR_kWh_s:
	rcall BEEP_100ms
	rcall WAIT_100ms
	dec temp9
	brne MENUE_CLEAR_kWh_s
	rjmp RESET
;-------------------------------------------------------------------------------
; Menue Taste gedrckt															
MENUE_PLUS:
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	rjmp MENUE_RUN	
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)	; Z initialisieren	
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp 
	adc ZH,NULL
	ijmp			; SPRUNG nach Z		
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_kWh
	rjmp MENUE_P_P_max
	rjmp MENUE_U_i

	rjmp MENUE_U_P


	rjmp MENUE_TEMPERATUR
	rjmp MENUE_ADC_U
	rjmp MENUE_ADC_i
	rjmp MENUE_ADC_T
	rjmp MENUE_BAUSTELLE
	rjmp MENUE_UHR
	rjmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL	; berlauf
	rjmp MENUE_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	STS(adr_DIGIT7),VOLL
	STS(adr_DIGIT6),VOLL
	STS(adr_DIGIT5),VOLL
	STS(adr_DIGIT4),VOLL
	STS(adr_DIGIT3),VOLL
	STS(adr_DIGIT2),VOLL
	STS(adr_DIGIT1),VOLL
	STS(adr_DIGIT0),VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; kWh																			
MENUE_kWh:
	LDS temp1,(adr_Ws_0)
	LDS temp2,(adr_Ws_1)
	LDS temp3,(adr_Ws_2)
	LDS temp4,(adr_Ws_3)

	ldi temp5,BYTE1(360)
	ldi temp6,BYTE2(360)
	ldi temp7,BYTE3(360)
	ldi temp8,BYTE4(360)
	rcall DIVISION_32_32
	rcall FUNKTION_HEX_ASCII_TEMP1_4

	cpi temp8,(ASCII_0)
	brne MENUE_kWh_RUN
	clr temp8

	cpi temp7,(ASCII_0)
	brne MENUE_kWh_RUN
	clr temp7

	cpi temp6,(ASCII_0)
	brne MENUE_kWh_RUN
	clr temp6

MENUE_kWh_RUN:
	STS(adr_DIGIT7),temp8
	STS(adr_DIGIT6),temp7
	STS(adr_DIGIT5),temp6
	ori temp5,(ASCII_PUNKT)	;Punkt	
	STS(adr_DIGIT4),temp5


	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leistung momentan / max														
MENUE_P_P_max:
	LDS temp1,(adr_P)
	rcall ZAHL_TEMP1

	cpi temp3,(ASCII_0)
	brne MENUE_P_w1
	clr temp3

	cpi temp2,(ASCII_0)
	brne MENUE_P_w1
	clr temp2
;-------------------------------------------------------------------------------
MENUE_P_w1:
	ldi temp,(ASCII_P)
	STS(adr_DIGIT7),temp
	STS(adr_DIGIT6),temp3
	STS(adr_DIGIT5),temp2
	STS(adr_DIGIT4),temp1

	LDS temp1,(adr_P_MAX)
	rcall ZAHL_TEMP1

	cpi temp3,(ASCII_0)
	brne MENUE_P_w2
	clr temp3

	cpi temp2,(ASCII_0)
	brne MENUE_P_w2
	clr temp2
;-------------------------------------------------------------------------------
MENUE_P_w2:
	ldi temp,(ASCII_PEAK)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; U / i																			
MENUE_U_i:
	LDS temp1,(adr_U)
	rcall ZAHL_TEMP1
	STS(adr_DIGIT7),temp3
	ori temp2,(ASCII_PUNKT)	; Punkt	
	STS(adr_DIGIT6),temp2
	STS(adr_DIGIT5),temp1
	ldi temp,(ASCII_V)
	STS(adr_DIGIT4),temp

	LDS temp1,(adr_i)
	rcall ZAHL_TEMP1
	STS(adr_DIGIT3),temp3
	ori temp2,(ASCII_PUNKT);Punkt
	STS(adr_DIGIT2),temp2
	STS(adr_DIGIT1),temp1
	ldi temp,(ASCII_A)
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; U / Leistung																	
MENUE_U_P:
	LDS temp1,(adr_U)
	rcall ZAHL_TEMP1


	ldi temp,(ASCII_V)		; V		
	STS(adr_DIGIT7),temp

	STS(adr_DIGIT6),temp3
	ori temp2,(ASCII_PUNKT)	; Punkt	
	STS(adr_DIGIT5),temp2
	STS(adr_DIGIT4),temp1



	LDS temp1,(adr_P)
	rcall ZAHL_TEMP1

	cpi temp3,(ASCII_0)
	brne MENUE_U_P_w1
	clr temp3

	cpi temp2,(ASCII_0)
	brne MENUE_U_P_w1
	clr temp2
;-------------------------------------------------------------------------------
MENUE_U_P_w1:
	ldi temp,(ASCII_P)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEMPERATUR:
	STS(adr_DIGIT7),NULL
	STS(adr_DIGIT6),NULL
	ldi temp,(ASCII_GRAD)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_C)
	STS(adr_DIGIT4),temp

	LDS temp1,(adr_T)
	rcall ZAHL_TEMP1
	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC0 (U)																		
MENUE_ADC_U:
	ldi temp,(ASCII_A)
	STS(adr_DIGIT7),temp
	ldi temp,(ASCII_D)
	STS(adr_DIGIT6),temp
	ldi temp,(ASCII_C)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_0)
	STS(adr_DIGIT4),temp


	LDS temp1,(adr_ADC_U_L)
	LDS temp2,(adr_ADC_U_H)
	rcall ZAHL_TEMP1_2
	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC1 (i)																		
MENUE_ADC_i:
	ldi temp,(ASCII_A)
	STS(adr_DIGIT7),temp
	ldi temp,(ASCII_D)
	STS(adr_DIGIT6),temp
	ldi temp,(ASCII_C)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_1)
	STS(adr_DIGIT4),temp

	LDS temp1,(adr_ADC_i_L)
	LDS temp2,(adr_ADC_i_H)
	rcall ZAHL_TEMP1_2
	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC2 (Temperatur)																
MENUE_ADC_T:
	ldi temp,(ASCII_A)
	STS(adr_DIGIT7),temp
	ldi temp,(ASCII_D)
	STS(adr_DIGIT6),temp
	ldi temp,(ASCII_C)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_2)
	STS(adr_DIGIT4),temp



	LDS temp1,(adr_ADC_2_L)
	LDS temp2,(adr_ADC_2_H)
	rcall ZAHL_TEMP1_2
	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1

	LDS temp2,(adr_ADC_U_H)
	rcall ZAHL_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_UHR:
	; hh								
	LDS temp1,(adr_hh_L)
	LDS temp2,(adr_hh_H)
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	STS(adr_DIGIT7),temp4
	STS(adr_DIGIT6),temp3
	STS(adr_DIGIT5),temp2
	ori temp1,(ASCII_PUNKT)
	STS(adr_DIGIT4),temp1
	; mm								
	LDS temp1,(adr_mm)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	STS(adr_DIGIT3),temp2
	ori temp1,(ASCII_PUNKT)
	STS(adr_DIGIT2),temp1
	; ss								
	LDS temp1,(adr_ss)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	STS(adr_DIGIT1),temp2
	ori temp1,(ASCII_PUNKT)
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

