; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; ZWEI				
	ldi temp,2
	mov ZWEI,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; Error				
	clr ERROR
	; DIGIT off			
	STS(adr_DIGIT7),NULL
	STS(adr_DIGIT6),NULL
	STS(adr_DIGIT5),NULL
	STS(adr_DIGIT4),NULL

	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT0),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEGRUESSUNG:
	ldi temp,(ASCII_2)
	STS(adr_DIGIT7),temp
	ldi temp,(ASCII_0)
	STS(adr_DIGIT6),temp
	ldi temp,(ASCII_2)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_5)
	STS(adr_DIGIT4),temp

	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT0),NULL


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
;-------------------------------------------------------------------------------
; auf AUSGANG																	
	sbi (BEEP_DDR),(BEEP_PIN_NR)		; BEEP		
	sbi (POWER_DDR),(POWER_PIN_NR)		; POWER		
	sbi (LUEFTER_DDR),(LUEFTER_PIN_NR)	; LFTER	

	sbi (GRUEN_DDR),(GRUEN_PIN_NR)		; GRN		
	sbi (GELB_DDR) ,(GELB_PIN_NR)		; GELB		
	sbi (ROT_DDR)  ,(ROT_PIN_NR)		; ROT		
	sbi (GRUEN2_DDR),(GRUEN2_PIN_NR)	; GRN		
	sbi (GELB2_DDR) ,(GELB2_PIN_NR)		; GELB		
	BEEP_OFF
	POWER_OFF
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	GRUEN2_OFF
	GELB2_OFF
;-------------------------------------------------------------------------------
; Display																		
	sbi (CLOCK_DDR),(CLOCK_PIN_NR)		; LED		
	sbi (DAT_DDR)  ,(DAT_PIN_NR)		; LED		
;-------------------------------------------------------------------------------
; Tasten																		
	cbi (TASTE_C_DDR) ,(TASTE_C_PIN_NR)	; Taste C	
	cbi (TASTE_M_DDR) ,(TASTE_M_PIN_NR)	; Taste M	
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)	; Pull-Up	
	sbi (TASTE_M_PORT),(TASTE_M_PIN_NR)	; Pull-Up	
;  LED-Test																		
	LUEFTER_ON
	rcall wait_10ms
	LUEFTER_OFF

	GRUEN_ON
	rcall wait_100ms
	GELB_ON
	rcall wait_100ms
	ROT_ON
	rcall wait_100ms
	GRUEN2_ON
	rcall wait_100ms
	GELB2_ON
	rcall wait_100ms

	ROT_OFF
	GRUEN_OFF
	GELB_OFF
	GRUEN2_OFF
	GELB2_OFF


	POWER_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STOP:
	WDR
	rjmp STOP 
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; ZWEI		
	mov temp,ZWEI
	cpi temp,2
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	rcall BEEP_10ms
	GRUEN_ON
	GELB_ON
	ROT_ON
	rcall WAIT_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_CHECK_ERROR
;########################################################################
;########################################################################
;########################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	rcall WAIT_100ms
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
	rcall WAIT_200ms

	STS(adr_TASTE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_1ms:
	BEEP_ON
	rcall WAIT_1ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_10ms:
	BEEP_ON
	rcall WAIT_10ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_20ms:
	BEEP_ON
	rcall WAIT_20ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_50ms:
	BEEP_ON
	rcall WAIT_50ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_100ms:
	BEEP_ON
	rcall WAIT_100ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_1s:
	BEEP_ON
	rcall WAIT_1s
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_MINUS:
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT7),temp
	STS(adr_DIGIT6),temp
	STS(adr_DIGIT5),temp
	STS(adr_DIGIT4),temp
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY_VOLL:
	ldi temp,(ASCII_VOLL)
	STS(adr_DIGIT7),temp
	STS(adr_DIGIT6),temp
	STS(adr_DIGIT5),temp
	STS(adr_DIGIT4),temp
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY_OFF:
	clr temp
	STS(adr_DIGIT7),temp
	STS(adr_DIGIT6),temp
	STS(adr_DIGIT5),temp
	STS(adr_DIGIT4),temp
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
ret
;#######################################################################
;#######################################################################
;#######################################################################
; Version: 22.10.2015													
; 																		
; 	INPUT: 	TEMP1....TEMP4 (0....4.294.967.295)	Divident				
;			TEMP5....TEMP8 (1....4.294.967.295)	Divisor 				
;																		
; 	OUTPUT;	TEMP1....TEMP5 (0....4.294.967.295) Quotient				
;																		
;	Hilfsregister: R0,R1,R2,R3,R4,R5,R6;R7,TEMP							
;																		
DIVISION_32_32:
; FEHLERPRFUNG (Divisor >0)			
	tst  temp5
	brne DIVISION_32_32_RUN
	tst  temp6
	brne DIVISION_32_32_RUN
	tst  temp7
	brne DIVISION_32_32_RUN
	tst  temp8
	brne DIVISION_32_32_RUN
; FEHLER ==> Null						
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	clr temp5
	clr temp6
	clr temp7
	clr temp8
	ret
;-----------------------------------------------------------------------
; Register sichern														
DIVISION_32_32_RUN:
	push R0
	push R1
	push R2
	push R3
	push R4
	push R5
	push R6
	push R7
;-----------------------------------------------------------------------
; aufrunden	(halben Devisor dazuaddieren)								
	mov R0,temp5	; kopieren	
	mov R1,temp6
	mov R2,temp7
	mov R3,temp8
	LSR R3			; durch 2	
	ROR R2
	ROR R1
	ROR R0
	add temp1,R0	; addieren	
	adc temp2,R1
	adc temp3,R2
	adc temp4,R3
;-----------------------------------------------------------------------
; Register Initialisieren	
	ldi temp,1
	mov	R0,temp				; HILFSREGISTER =1 
	clr R1
	clr R2
	clr R3
	clr R4					; ERGEBNIS			
	clr R5
	clr R6
	clr R7
;-----------------------------------------------------------------------
; Divisor linksbndig 	
DIVISION_32_32_LINKS:
	tst	temp8					; Linksbndig ?		
	brmi DIVISION_32_32_START	; ja ==> SPRUNG		

	LSL R0						; HILFSREGISTER 1x links	
	ROL R1
	ROL R2
	ROL R3

	LSL temp5					; DIVISOR 1x links	
	ROL temp6
	ROL temp7
	ROL temp8
	rjmp DIVISION_32_32_LINKS

; DIVISION START		
DIVISION_32_32_START:
	cp	temp4,temp8					; DIVIDENT ">=" DIVISOR	?	(H_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__w
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__w:
	cp	temp3,temp7					; DIVIDENT ">=" DIVISOR	?	(H_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__ww
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__ww:
	cp	temp2,temp6					; DIVIDENT ">=" DIVISOR	?	(L_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__www
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__www:
	cp	temp1,temp5					; DIVIDENT ">=" DIVISOR	?	(L_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						

; ADDIEREN 					
DIVISION_32_32_ADD_SUB:
	add	R4,R0						; ERGEBNIS vergrern 				
	adc R5,R1
	adc R6,R2
	adc R7,R3

	sub	temp1,temp5					; DIVIDENT verkleinern				
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8

; 1 x rechts schieben		
DIVISION_32_32_SCHIEBEN:
	LSR	temp8						; DIVISOR 1 x rechts				
	ROR temp7
	ROR temp6
	ROR temp5

	LSR	R3							; HILFSREGISTER => 1 x rechts		
	ROR R2
	ROR R1
	ROR R0

; HILFSREGISTER=0 ?						
	TST R3							; =0 ?								
	brne DIVISION_32_32_START		; nein ==> SPRUNG					
	TST R2
	brne DIVISION_32_32_START			
	TST R1
	brne DIVISION_32_32_START	
	TST R0
	brne DIVISION_32_32_START	
; ERGEBNIS nach temp1...Temp4 kopieren	
	mov temp1, R4
	mov temp2, R5
	mov temp3, R6
	mov temp4, R7
; REGISTER wiederherstellen				
	pop R7
	pop R6
	pop R5
	pop R4
	pop R3
	pop R2
	pop R1
	pop R0
ret 
;########################################################################
;########################################################################
;########################################################################


