;												
; fr ATmega8									
; Bernhard.Erfurt@gmx.de						
; 01/2025										
;												

;												
; LED ROT blinkt: Programm Check Error			
; LED ROT+GELB blinkt: Interrupt Error			
; LED ROT+GELB+GRN blinkt: WDR Error (nicht in dieser Version)	
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; KONSTANTEN									
.equ TAKT						=1000000	; 1 MHz	
; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ASCII_0					=0b00111111	; 0 
.equ ASCII_1					=0b00000110	; 1 
.equ ASCII_2					=0b01011011	; 2 
.equ ASCII_3					=0b01001111	; 3 
.equ ASCII_4					=0b01100110	; 4 
.equ ASCII_5					=0b01101101	; 5 
.equ ASCII_6					=0b01111101	; 6 
.equ ASCII_7					=0b00000111	; 7 
.equ ASCII_8					=0b01111111	; 8 
.equ ASCII_9					=0b01101111	; 9 

.equ ASCII_AUS					=0b00000000	; ''
.equ ASCII_PUNKT				=0b10000000	; . 
.equ ASCII_VOLL					=0b11111111	; 8.
.equ ASCII_MINUS				=0b01000000	; - 
.equ ASCII_GRAD					=0b01100011	;  
.equ ASCII_PEAK					=0b00100011	; 	

.equ ASCII_A					=0b01110111	; A 
.equ ASCII_B					=0b01111100	; B 
.equ ASCII_C					=0b01011000	; C 
.equ ASCII_D					=0b01011110	; D 
.equ ASCII_E					=0b01111001	; E 
.equ ASCII_F					=0b01110001	; F 
.equ ASCII_H_					=0b01110100	; h 
.equ ASCII_V					=0b00111110	; V 

.equ ASCII_P					=0b01110011	; P
.equ ASCII_U					=0b00111110	; U
.equ ASCII_L					=0b00111000	; L
.equ ASCII_S					=0b01101101	; S
.equ ASCII_K					=0b00110100	; K

; TASTE "M"	(Menue)								
.equ TASTE_M_PIN_NR				= 0
.equ TASTE_M_PIN				= PINB
.equ TASTE_M_DDR				= DDRB
.equ TASTE_M_PORT				= PORTB
; TASTE "C"	(Clear)								
.equ TASTE_C_PIN_NR				= 1
.equ TASTE_C_PIN				= PINB
.equ TASTE_C_DDR				= DDRB
.equ TASTE_C_PORT				= PORTB
; LFTER										
.equ LUEFTER_PIN_NR				= 2
.equ LUEFTER_DDR				= DDRB
.equ LUEFTER_PORT				= PORTB
; Power (Display)								
.equ POWER_PIN_NR				= 4
.equ POWER_DDR					= DDRC
.equ POWER_PORT					= PORTC
; BEEP											
.equ BEEP_PIN_NR				= 5
.equ BEEP_DDR					= DDRC
.equ BEEP_PORT					= PORTC
; LED-GRUEN-2									
.equ GRUEN2_PIN_NR				= 1
.equ GRUEN2_DDR					= DDRD
.equ GRUEN2_PORT				= PORTD
; LED-GELB-2									
.equ GELB2_PIN_NR				= 2
.equ GELB2_DDR					= DDRD
.equ GELB2_PORT					= PORTD
; CP(Clock)										
.equ CLOCK_PIN_NR				= 3
.equ CLOCK_DDR					= DDRD
.equ CLOCK_PORT					= PORTD
; DAT(Daten)									
.equ DAT_PIN_NR					= 4
.equ DAT_DDR					= DDRD
.equ DAT_PORT					= PORTD
; LED-GRUEN										
.equ GRUEN_PIN_NR				= 5
.equ GRUEN_DDR					= DDRD
.equ GRUEN_PORT					= PORTD
; LED-GELB										
.equ GELB_PIN_NR				= 6
.equ GELB_DDR					= DDRD
.equ GELB_PORT					= PORTD
; LED-ROT										
.equ ROT_PIN_NR					= 7
.equ ROT_DDR					= DDRD
.equ ROT_PORT					= PORTD

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_VT1						=SRAM_START+5
.equ adr_VT2						=SRAM_START+6

.equ adr_FREIGABE_ss				=SRAM_START+8

.equ adr_ss							=SRAM_START+10
.equ adr_mm							=SRAM_START+11
.equ adr_hh_L						=SRAM_START+12
.equ adr_hh_H						=SRAM_START+13

.equ adr_COUNTER_MENUE				=SRAM_START+16

.equ adr_DIGIT_NR					=SRAM_START+20	; 0...7						
.equ adr_DIGIT0						=SRAM_START+21	; unten rechts				
.equ adr_DIGIT1						=SRAM_START+22	
.equ adr_DIGIT2						=SRAM_START+23	
.equ adr_DIGIT3						=SRAM_START+24	
.equ adr_DIGIT4						=SRAM_START+25	
.equ adr_DIGIT5						=SRAM_START+26	
.equ adr_DIGIT6						=SRAM_START+27	
.equ adr_DIGIT7						=SRAM_START+28	

.equ adr_MENUE						=SRAM_START+100
.equ adr_TASTE						=SRAM_START+101

.equ adr_U							=SRAM_START+110		; Spanung		
.equ adr_i							=SRAM_START+111		; Strom			
.equ adr_P							=SRAM_START+113		; Leistung		
.equ adr_P_max						=SRAM_START+114		; Leistung		

.equ adr_T							=SRAM_START+115		; Temperatur	

.equ adr_Ws_0						=SRAM_START+125
.equ adr_Ws_1						=SRAM_START+126
.equ adr_Ws_2						=SRAM_START+127
.equ adr_Ws_3						=SRAM_START+128

.equ adr_ADC_U_L					=SRAM_START+150
.equ adr_ADC_U_H					=SRAM_START+151
.equ adr_ADC_i_L					=SRAM_START+152
.equ adr_ADC_i_H					=SRAM_START+153
.equ adr_ADC_2_L					=SRAM_START+154
.equ adr_ADC_2_H					=SRAM_START+155
.equ adr_ADC_3_L					=SRAM_START+156
.equ adr_ADC_3_H					=SRAM_START+157
.equ adr_ADC_4_L					=SRAM_START+158
.equ adr_ADC_4_H					=SRAM_START+159
.equ adr_ADC_5_L					=SRAM_START+160
.equ adr_ADC_5_H					=SRAM_START+161

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def ERROR		= R8
.def TIMER0		= R9

.def NULL 		= R12
.def EINS 		= R13
.def ZWEI 		= R14
.def VOLL		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	GELB_ON
	ROT_ON
	rcall wait_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
; Reset																			
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren				
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG				
	rcall SRAM_CLEAR						; SRAM lschen						
	rcall STARTWERTE						; Startwerte						
	rcall ADC_INITIALISIERUNG				; ADC_INITIALISIERUNG				
	rcall PORT_INITIALISIERUNG				; PORT_CLEAR						
	rcall BEGRUESSUNG
	rcall TIMER0_INITIALISIERUNG_1ms		; TIMER								
	rcall TIMER_AKTIVIEREN					; TIMER								
	sei										; Interrupts freigeben				
	rcall EEPROM_LOAD						; EEPROM							
	rcall PROGRAMM_CHECK					; CHECK								
;-------------------------------------------------------------------------------
; 13V Startspaannung ?															
STARTSPANNUNG:
	rcall ADC_U
	LDS temp,(adr_U)
	cpi temp,130	; 13V 
	brlo BATTERIE
	rjmp RESET_RUN
;-------------------------------------------------------------------------------
; Batteriebetrieb																
BATTERIE:
	GRUEN_OFF
	ROT_ON
	rcall BEEP_20ms
	GELB_OFF
	GRUEN2_OFF
	GELB2_OFF
	rcall WAIT_100ms
	ROT_OFF
	rcall WAIT_100ms
	rcall MENUE_kWh
	rjmp STARTSPANNUNG
;-------------------------------------------------------------------------------
RESET_RUN:
	rcall BEEP_10ms
	rcall WAIT_100ms
	rcall BEEP_10ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall ADC_T
	rcall ADC_U
	rcall ADC_i
	rcall BERECHNUNG_P
	rcall BERECHNUNG_P_MAX
	rcall BERECHNUNG_Ws
	rcall BERECHNUNG_10V_UNTERSPANNUNG
	rcall MENUE
	rcall TASTEN_WAIT
	rcall PROGRAMM_CHECK

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_10V_UNTERSPANNUNG:
	LDS temp,(adr_U)		; z.B: 200=20,0V
	cpi temp,100
	brlo BERECHNUNG_10V_UNTERSPANNUNG_RUN
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_10V_UNTERSPANNUNG_RUN:
	LUEFTER_OFF
	STS(adr_DIGIT7),NULL
	STS(adr_DIGIT6),NULL
	STS(adr_DIGIT5),NULL
	STS(adr_DIGIT4),NULL
	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT0),NULL
	rcall EEPROM_SAVE	
	GRUEN_ON
	rcall BEEP_20ms
BERECHNUNG_10V_UNTERSPANNUNG_NEUSTART:
	rjmp BERECHNUNG_10V_UNTERSPANNUNG_NEUSTART
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung Ws (WattSekunden)													
BERECHNUNG_Ws:
	LDS temp,(adr_Freigabe_ss)
	tst temp
	brne BERECHNUN1G_Ws_RUN
	ret
;-------------------------------------------------------------------------------
BERECHNUN1G_Ws_RUN:
	STS(adr_Freigabe_ss),NULL
	GRUEN_ON
	rcall WAIT_10ms
	GRUEN_OFF

	LDS temp1,(adr_P)
	clr temp2
	clr temp3
	clr temp4
	LDS temp5,(adr_Ws_0)
	LDS temp6,(adr_Ws_1)
	LDS temp7,(adr_Ws_2)
	LDS temp8,(adr_Ws_3)
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	STS(adr_Ws_0),temp1
	STS(adr_Ws_1),temp2
	STS(adr_Ws_2),temp3
	STS(adr_Ws_3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung P (Leistung)														
BERECHNUNG_P:
	LDS temp1,(adr_U)		; z.B: 200=20,0V
	LDS temp2,(adr_i)		; z.B:  10= 1,0A
	; U x i					
	mul temp1,temp2			; Z.B:2000		
	; durch 1000			
	mov temp1,R0			; Divident		
	mov temp2,R1
	clr temp3 
	clr temp4
	ldi temp5,Byte1(100)	; Divisor		
	ldi temp6,Byte2(100)
	ldi temp7,Byte3(100)
	ldi temp8,Byte4(100)
	rcall DIVISION_32_32
	STS(adr_P),temp1		; z.B.  20=20W	
	; Lfter on/off			
	cpi temp1,45			; 45 Watt		
	brlo BERECHNUNG_P_LUEFTER_OFF
	cpi temp1,50			; 50 Watt		
	brsh BERECHNUNG_P_LUEFTER_ON
	cpi temp1,45			; 45 Watt		
	brsh BERECHNUNG_P_LUEFTER_WAIT
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_P_LUEFTER_WAIT:
	GRUEN2_ON
	rcall WAIT_100ms
	GRUEN2_OFF
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_P_LUEFTER_OFF:
	GRUEN2_OFF
	LUEFTER_OFF
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_P_LUEFTER_ON:
	GRUEN2_ON
	LUEFTER_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung P-MAX (Leistung)													
BERECHNUNG_P_MAX:
	LDS temp1,(adr_P)
	LDS temp2,(adr_P_MAX)
	cp temp1,temp2
	breq P_EXIT
	brsh P_GROESSER
	brlo P_EXIT
;-------------------------------------------------------------------------------
P_GROESSER:
	STS(adr_P_MAX),temp1
;-------------------------------------------------------------------------------
P_EXIT:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "TIMER.asm"
.include "DISPLAY.asm"
.include "EEPROM.asm"
.include "SONSTIGES.asm"
.include "MENUE.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"

